/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGDataConsumer;

import dstep.applicationservices.coregraphics.CGBase;
import dstep.corefoundation.CFData;
import dstep.corefoundation.CFURL;
//import dstep.stddef;

struct CGDataConsumer; 

alias CGDataConsumer* CGDataConsumerRef;

extern (C)
{
	alias void function (void*) CGDataConsumerReleaseInfoCallback;
	alias uint function (void*, void*, uint) CGDataConsumerPutBytesCallback;
}

struct CGDataConsumerCallbacks
{
	CGDataConsumerPutBytesCallback putBytes;
	CGDataConsumerReleaseInfoCallback releaseConsumer;
}

extern (C)
{
	uint CGDataConsumerGetTypeID ();
	CGDataConsumerRef CGDataConsumerCreate (void* info, CGDataConsumerCallbacks* callbacks);
	CGDataConsumerRef CGDataConsumerCreateWithURL (CFURLRef url);
	CGDataConsumerRef CGDataConsumerCreateWithCFData (CFMutableDataRef data);
	CGDataConsumerRef CGDataConsumerRetain (CGDataConsumerRef consumer);
	void CGDataConsumerRelease (CGDataConsumerRef consumer);
}