/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGGradient;

import dstep.corefoundation.CFArray;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGColorSpace;
import dstep.applicationservices.coregraphics.CGContext;
//import dstep.stdint;

struct CGGradient;

alias CGGradient* CGGradientRef;
alias uint CGGradientDrawingOptions;

enum
{
	kCGGradientDrawsBeforeStartLocation = (1 << 0),
	kCGGradientDrawsAfterEndLocation = (1 << 1)
}

extern (C)
{
	uint CGGradientGetTypeID ();
	CGGradientRef CGGradientCreateWithColorComponents (CGColorSpaceRef space, CGFloat* components, CGFloat* locations, uint count);
	CGGradientRef CGGradientCreateWithColors (CGColorSpaceRef space, CFArrayRef colors, CGFloat* locations);
	CGGradientRef CGGradientRetain (CGGradientRef gradient);
	void CGGradientRelease (CGGradientRef gradient);
}