/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFContentStream;

import dstep.corefoundation.CFArray;

import dstep.applicationservices.coregraphics.CGPDFDictionary;
import dstep.applicationservices.coregraphics.CGPDFObject;
import dstep.applicationservices.coregraphics.CGPDFPage;
import dstep.applicationservices.coregraphics.CGPDFStream;

struct CGPDFContentStream;

alias CGPDFContentStream* CGPDFContentStreamRef;

extern (C)
{
	CGPDFContentStreamRef CGPDFContentStreamCreateWithPage (CGPDFPageRef page);
	CGPDFContentStreamRef CGPDFContentStreamCreateWithStream (CGPDFStreamRef stream, CGPDFDictionaryRef streamResources, CGPDFContentStreamRef parent);
	CGPDFContentStreamRef CGPDFContentStreamRetain (CGPDFContentStreamRef cs);
	void CGPDFContentStreamRelease (CGPDFContentStreamRef cs);
	CFArrayRef CGPDFContentStreamGetStreams (CGPDFContentStreamRef cs);
	CGPDFObjectRef CGPDFContentStreamGetResource (CGPDFContentStreamRef cs, char* category, char* name);
}