/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFStringTokenizer;

import dstep.corefoundation.CFArray;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFLocale;
import dstep.corefoundation.CFString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFStringTokenizer;
alias __CFStringTokenizer* CFStringTokenizerRef;
alias uint CFStringTokenizerTokenType;

enum
{
	kCFStringTokenizerUnitWord = 0,
	kCFStringTokenizerUnitSentence = 1,
	kCFStringTokenizerUnitParagraph = 2,
	kCFStringTokenizerUnitLineBreak = 3,
	kCFStringTokenizerUnitWordBoundary = 4,
	kCFStringTokenizerAttributeLatinTranscription = 1L << 16,
	kCFStringTokenizerAttributeLanguage = 1L << 17
}

enum
{
	kCFStringTokenizerTokenNone = 0,
	kCFStringTokenizerTokenNormal = 1,
	kCFStringTokenizerTokenHasSubTokensMask = 1L << 1,
	kCFStringTokenizerTokenHasDerivedSubTokensMask = 1L << 2,
	kCFStringTokenizerTokenHasHasNumbersMask = 1L << 3,
	kCFStringTokenizerTokenHasNonLettersMask = 1L << 4,
	kCFStringTokenizerTokenIsCJWordMask = 1L << 5
}

extern (C)
{
	CFStringRef CFStringTokenizerCopyBestStringLanguage (CFStringRef string, CFRange range);
	uint CFStringTokenizerGetTypeID ();
	CFStringTokenizerRef CFStringTokenizerCreate (CFAllocatorRef alloc, CFStringRef string, CFRange range, uint options, CFLocaleRef locale);
	void CFStringTokenizerSetString (CFStringTokenizerRef tokenizer, CFStringRef string, CFRange range);
	uint CFStringTokenizerGoToTokenAtIndex (CFStringTokenizerRef tokenizer, int index);
	uint CFStringTokenizerAdvanceToNextToken (CFStringTokenizerRef tokenizer);
	CFRange CFStringTokenizerGetCurrentTokenRange (CFStringTokenizerRef tokenizer);
	void* CFStringTokenizerCopyCurrentTokenAttribute (CFStringTokenizerRef tokenizer, uint attribute);
	int CFStringTokenizerGetCurrentSubTokens (CFStringTokenizerRef tokenizer, CFRange* ranges, int maxRangeLength, CFMutableArrayRef derivedSubTokens);
}