/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.carboncore.DriverSynchronization;

//import dstep.AvailabilityMacros;
import dstep.coreservices.carboncore.ConditionalMacros;
import dstep.coreservices.carboncore.MacTypes;

extern (C)
{
	ubyte CompareAndSwap (uint oldValue, uint newValue, UInt32* address);
	ubyte TestAndClear (uint bit, char* address);
	ubyte TestAndSet (uint bit, char* address);
	byte IncrementAtomic8 (char* address);
	byte DecrementAtomic8 (char* address);
	byte AddAtomic8 (int amount, char* address);
	ubyte BitAndAtomic8 (uint mask, char* address);
	ubyte BitOrAtomic8 (uint mask, char* address);
	ubyte BitXorAtomic8 (uint mask, char* address);
	short IncrementAtomic16 (SInt16* address);
	short DecrementAtomic16 (SInt16* address);
	short AddAtomic16 (int amount, SInt16* address);
	ushort BitAndAtomic16 (uint mask, UInt16* address);
	ushort BitOrAtomic16 (uint mask, UInt16* address);
	ushort BitXorAtomic16 (uint mask, UInt16* address);
	int IncrementAtomic (SInt32* address);
	int DecrementAtomic (SInt32* address);
	int AddAtomic (int amount, SInt32* address);
	uint BitAndAtomic (uint mask, UInt32* address);
	uint BitOrAtomic (uint mask, UInt32* address);
	uint BitXorAtomic (uint mask, UInt32* address);
}